<?php
/*
Importer Name: Splinder Grabber
Importer URI: http://www.fullo.net
Description: S/MI Imports posts, comments and categories from Splinder/Motime.com to Wordpress based on <a href="http://www.terenzani.it/38/importare-i-post-di-splinder-in-wordpress/">Splinder/Motime Importer</a> by Francesco Terenzani. Copy the file in wp-admin/import directory.
Version: 0.6.6
Author: Francesco Fullone
Author URI: http://www.fullo.net

Template model:
<Blogger>
<div class='ss-permalink'>:PERMALINKS:<$BlogItemPermalink$>:ENDPERMALINKS:</div>
<div class='ss-post-title'>:POSTTITLE:<$BlogItemTitle$>:ENDPOSTTITLE:</div>
<div class='ss-post-text'>:TESTO:<$BlogItemBody$>:ENDTESTO:</div>
<div class='ss-post-date'>:POSTDATA:<$BlogItemDateTime$>:ENDPOSTDATA:</div>
<div class='ss-post-cats'>:POSTCATEG:<$BlogItemCategories$>:ENDPOSTCATEG:</div>
<div class='ss-post-author'>:POSTAUTHOR:<$BlogItemAuthor$>:ENDPOSTAUTHOR:</div>
<div class='ss-comments'>:POSTCOMMENT:<$BlogItemCommentList$>:ENDPOSTCOMMENT:</div>
</Blogger>
:BLOGPAGER:<$BlogPager$>:ENDBLOGPAGER:

@TODO usare una funzione ajax per parsare le singole pagine indipendentemente dallo script php (refresh con js?)
@TODO creare una funzione di output (e relativi messaggi) decente
@TODO gestire post persi a livello di variabili interne

Change Log

0.6.6
- strip_tags for splinder titles

0.6.5
- fix for not saving options

0.6.4
- addslases to title and posts

0.6.3
- fix for import of lost posts
- refactor of manage() method
- new parameter for import_page method

0.6.1
- curl check
- get_permalinks return false if count( $this-permalinks ) < 0

0.6
- added import for any single page
- refactoring of methods
- more info on wp db

0.5.1
- added last_page check 
- added option var to decrease db access

0.5
- complete rewrite of the import routine
- parser logic moved to another class

0.4.1
- fix for removed sanitize_title on get_title() method

0.4
- added check_before() method
- fixed delete() method to remove also the meta_key

0.3
- added the save status on option
- added the "continue on error" functionality

*/

class Splinder_Parser {
	
	var $content = '';
	
	function title()
	{
		preg_match("#:POSTTITLE:(.+):ENDPOSTTITLE:#U", $this->content, $postTitle);
				
		if(!empty($postTitle)) return strip_tags($postTitle[1]);
		return false;
	}

	/**
	 * restituisce il corpo del post
	 *
	 * @param string $content
	 * @return string
	 */
	function body()
	{
		preg_match("#:TESTO:(.+):ENDTESTO:#sU", $this->content, $postText);
		preg_match("#(.+)<!--(.*)-->#sU", $postText[1], $postText);
		if(!empty($postText)) return convert_chars($postText[1]);
		return false;
	}
	
	// Critical function... Splinder don't return everytime the same date format...
	function date()
	{
		preg_match("#:POSTDATA:([0-9]{2})/([0-9]{2})/([0-9]{2,4}) ([0-9]{2}:[0-9]{2}):ENDPOSTDATA:#", $this->content, $postDate);
		if(empty($postDate)) return false;

		// if year is 2 chars length
		if(strlen($postDate[3])==2){
			// If > 7X = 197X; else 20XX... 64 years compatible :P
			$postDate[3] = (substr($postDate[3],0,1)>7) ? "19".$postDate[3] : "20".$postDate[3];
			return $postDate = "$postDate[3]-$postDate[1]-$postDate[2] $postDate[4]:01";
		}
		return $postDate = "$postDate[3]-$postDate[2]-$postDate[1] $postDate[4]:01";
	}
	
	/**
	 * Restituisce il nome dell'autore del post
	 *
	 * @param string $content
	 * @return string
	 */
	function author()
	{
		preg_match("#:POSTAUTHOR:(.+):ENDPOSTAUTHOR:>#",$this->content, $postAuthor);
		if(!empty($postAuthor)) return $postAuthor[1];
		return false;
	}

	/**
	 * restituisce l'array delle categorie
	 *
	 * @param string $content
	 * @return mixed
	 */
	function categories()
	{
		preg_match("#:POSTCATEG:.*:ENDPOSTCATEG:#U", $this->content, $postcats);
		preg_match_all("#<a href=\'.+\' rel='category tag'>([\w ]+)</a>[, ]*#U", $postcats[0], $cats);
		if(!empty($cats)) return $cats[1];
		return false;
	}

	function comments()
	{
		preg_match("#:POSTCOMMENT:.+:ENDPOSTCOMMENT:#s", $this->content, $comments);
		if(!empty($comments)) return $comments[0];
		return false;
	}

	function purge_comment_date($comments)
	{
		preg_match_all("#:right\">([0-9]{1,2}) ([\w]+) ([0-9]{4}) - ([0-9]{2}:[0-9]{2})#", $comments, $comDate);
		if(!empty($comDate)) return $comDate;
		return false;
	}
	
	function purge_comment_text($comments)
	{
		preg_match_all("#<div class=\"comment-body\">(.+)</div>#Us", $comments, $comBody);
		if(!empty($comBody)) return $comBody;
		return false;
	}
	
	function purge_comment_author($comments)
	{
		preg_match_all("#<td class=\"icons\">[\r\n\t]+(<a href=\"(.+)\".+)?</td>[\r\n\t]+<td>[\r\n\t]+([^\n\t\r]+)[\r\n\t]+</td>#Us", $comments, $comAuthor);
		if(empty($comAuthor[0])){
			preg_match_all("#<div class=\"comment-bottom\">[\r\n\t]+([^\n\t\r]+)[\r\n\t]+.+(<a href=\"(http://(?!www\.motime\.com).+)\"|<br />)#Us", $comments, $comAuthor);
			$comAuthor[2] = $comAuthor[3];
			$comAuthor[3] = $comAuthor[1];
		}

		if(!empty($comAuthor)) return $comAuthor;
		return false;
	}

	function utf8_decode()
	{
		$search = array("â€™", "â€¦", "â€œ", "â€");
		$replace = array("'", "...", '"', '"');
		$content = str_replace($search, $replace, $this->content);
		$content = mb_convert_encoding($this->content, get_option('blog_charset'), 'UTF-8');
		return $content;
	}

	function month_numberize($string){
		$a1 = array("gennaio", "febbraio", "marzo", "aprile", "maggio", "giugno", "luglio", "agosto", "settembre", "ottobre", "novembre", "dicembre");
		$a3 = array('january', 'february', 'mars', 'april', 'may', 'june', 'july', 'august', 'september', 'october', 'november', 'december');
		$a2 = array(1,2,3,4,5,6,7,8,9,10,11,12);
		$string = str_replace($a1,$a2,strtolower ($string));
		return $string = str_replace($a3,$a2,strtolower ($string));
	}
	
	function Splinder_Parser($content = '')
	{
		$this->content = $content;
	}
	
}

class Splinder_Importer {

	var $blog_url = '';
	var $error = array();
	var $permalinks = array();
	var $original_permalinks = array();
	var $imported = array();
	var $pages = array();
	var $no_title = 0;
	var $default_title = 'nessun titolo';
	var $limit = 61;
	var $last_page = -1;
	var $options = null;
	var $post_persi = array();
	
	/**
	 * Utilizza CURL per recuperare il contenuto di una pagina
	 * lo user agent è modificato a caso
	 *
	 * @param string $url
	 * @return $content string
	 */
	function curl_content($url) 
	{
		$ch = @curl_init($url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (X11; U; Linux i686; it; rv:1.8.1.10) Gecko/20071213 Fedora/2.0.0.".rand(0,10)."-3.fc".rand(4,8)." Firefox/2.0.0.".rand(0,10));
		$content = curl_exec($ch);

		if (curl_errno($ch)) 
		    $this->error[] = array('curl_error' => curl_error($ch), 'url' => $url);
		else
		    curl_close($ch);

		return $content;
	}

	/**
	 * controlla quali post sono effettivamente nel database
	 * e quali non sono invece stati scaricati.
	 * 
	 * aggiorna i dati nelle opzioni dell'importer, se tutto va a
	 * buon fine le opzioni sono cancellate.
	 *
	 */
	function check_results()
	{
		global $wpdb;
		
		$options = $this->options();
		
		$permalinks = $wpdb->get_results("SELECT meta_value FROM $wpdb->postmeta WHERE meta_key = 'splinder_permalink'");

		$post_persi = array();
		$post_su_db = array();
		
		echo "sono stati importati <b>".count($permalinks)."</b> su ".count($this->original_permalinks)." articoli ";
		if ($this->limit < count($this->permalinks)) echo " perchè superato il limite ammesso di ".$this->limit;
		echo "<br/>";
		
		
		if (count($this->post_persi)>0)
		{
			foreach ($permalinks as $permalink) 
				$post_su_db[] = str_replace($this->blog_url,'',$permalink->meta_value);

			// se ci sono più post in queue che importati
			$post_persi = array_diff($this->permalinks,$post_su_db);
			
			if (count(array_diff($this->post_persi,$post_persi))!=0) echo "non combacia!!!";
			echo "<br/>vuoi provare a reimportare i post <b>".count($post_persi)."</b> persi? [<b><a href='?import=splinder&amp;step=3'>SI</a></b>]<br/>";
		
		}
		
		// aggiorno le opzioni con lo storico aggiornamenti
		$this->options_update(array( 
					'post_persi' => $post_persi, 
					'blog_url' => $this->blog_url,
					'permalinks' => $this->permalinks,
					'pages' => $this->pages,
					'imported' => $this->imported,
					'last_page' => $this->last_page
					)
				);
																								
	}
	

	/**
	 * la funzione pulisce i permalink eliminando quelli già 
	 * importati
	 *
	 * @return boolean
	 */
	function check_before()
	{
		global $wpdb;
		$imported = $wpdb->get_results("SELECT post_id, meta_value FROM $wpdb->postmeta WHERE meta_value LIKE '$this->blog_url%' AND meta_key = 'splinder_permalink'" );
		
		if ($imported)
		{
			// controllo che i post presenti nel db non siano anche tra quelli parsati
			// se lo sono li sposto nell'array dei post già importati
			foreach ($imported as $posts) 
			{
				$permalink = str_replace($this->blog_url,'',$posts->meta_value);
				if (in_array($permalink, $this->permalinks))
					$this->imported[$posts->post_id] = $permalink;
			}
			
			// questa variabile contiene tutti i post finora parsati
			$this->original_permalinks = array_unique(array_merge($this->permalinks,$this->original_permalinks));
			$this->permalinks = array_diff($this->permalinks, $this->imported);
			
			return true;
		}
		
		return false;
		
	}
	
	
	/**
	 * Restituisce l'array con gli url della paginazione da valutare
	 *
	 * @return boolean
	 */
	function get_pages()
	{
		$contents = $this->curl_content($this->blog_url);

		if($contents){
			# Last page
			preg_match("#<a href=\"\?from=([0-9]+)\" rel=\"nofollow\">(ultima|last page)</a>#",$contents,$end);
			# Skip per page
			preg_match("#<a href=\"\?from=([0-9]+)\" rel=\"nofollow\">2</a>#",$contents,$page);
			# Page 1
			$urls[] = $this->blog_url;
			# All pages
					
			echo "<div>La paginazione sul blog: <b>".$this->blog_url."</b> ";			
			if (count($end) > 1) 
			{
				$skip = $page[1];
				while($page[1]<$end[1])
				{
					$urls[] = $this->blog_url ."?from=$page[1]";
		    		$page[1] = $page[1]+$skip;
				}
				$urls[] = $this->blog_url ."?from=$page[1]";
				
				echo " è attiva.<br/> Ho identificato ".count($urls). " pagine da importare.";
			} else " non è attiva, sarà indicizzata solo l'homepage del blog";
			
			echo "</div><br/>";

			$this->pages = $urls;
						
			return true;
		}
		return false;
	}

	/**
	 * Analizza una singola pagina degli archivi e genera l'array dei permalinks
	 * dei relativi post
	 *
	 * @return array page permalinks
	 */
	function get_permalinks($url)
	{
		$contents = $this->curl_content($url);
			
		$posts = array();
		preg_match_all("#:PERMALINKS:(/post/[0-9]+).*:ENDPERMALINKS:#",$contents,$post_urls);
		$posts = array_merge($posts, $post_urls[1]);

		if (count($posts)>0)
			return $posts;	
		else 
			return false;
	}
	
	/**
	 * Analizza le pagine degli archivi e genera l'array dei permalinks
	 * di tutti i post del blog
	 *
	 * @return boolean
	 */
	function get_all_permalinks()
	{
		if( (is_array($this->pages)) and (count($this->pages)>0) )
		{
			foreach($this->pages as $url)
				$this->permalinks = array_merge($this->permalinks,$this->get_permalinks($url));	
			
			return true;
		}
		return false;
	}

	/**
	 * Analizza, pulisce e salva il post nel db di wordpress
	 *
	 * @param string $url
	 * @return boolean
	 */
	function save($url)
	{		
		$content = $this->curl_content($url);

		if($content)
		{
			$parser = new Splinder_Parser($content);
			
			if(strtoupper(get_option('blog_charset')) != 'UTF-8')
				$parser->utf8_decode();
						
			$post_title = addslashes($parser->title());
			$post_content = addslashes($parser->body());

			if (!$post_content) return false;
			else {
				
				if(!$post_title)
				{
					$post_title = $this->default_title;
					$this->no_title++;
				}

				$post_date = $parser->date();
				$author = $parser->author();
				
				$post_author = $this->save_author($author);
				$post_status = 'publish';
				
				$postdata = compact('post_author', 'post_date', 'post_content', 'post_title','post_status');
				$post_ID = wp_insert_post($postdata);
				
				//if (is_numeric($post_ID))
				if (get_permalink($post_ID)!='') //workaround 
				{ 
					$cats = $parser->categories();
					wp_create_categories( array_map( 'addslashes', $cats ), $post_ID );
								
					$comments = $parser->comments();
					if($comments){
						$comment_date = $parser->purge_comment_date($comments);
						$comment_text = $parser->purge_comment_text($comments);
						$comment_author = $parser->purge_comment_author($comments);
						$comCount = count($comment_date[0]);
					}		
					$this->save_comments($post_ID, $comment_author, $comment_date, $comment_text);
	
					add_post_meta( $post_ID, 'splinder_blog', $this->blog_url, true );
					add_post_meta( $post_ID, 'splinder_permalink', $url, true );

					echo '<a href="'.get_permalink($post_ID).'" title="nuovo id del post">nuovo id: '.$post_ID.'</a><br/>';					
					echo '<div style="font-size:8px">';
					if (count($cats) > 0)
						echo 'aggiungo il post alle categorie: '.implode(', ',$cats);
					else 
						echo 'nessuna categoria trovata';
					echo '</div>';
					
					$this->imported[$post_ID] = str_replace($this->blog_url,'',$url);
					
					return $post_ID;
				}
				else
					$this->post_persi[] = str_replace($this->blog_url,'',$url);
				
			    	return false;
		 	}
		}
		
		return false;
	}

	/**
	 * Salve l'autore nel db
	 *
	 * @param string $nick
	 * @return $authorID
	 */	
	function save_author($nick='')
	{
		global $wpdb;
		if(!empty($nick))
		{
			$authorID = $wpdb->get_var("SELECT ID FROM $wpdb->users WHERE display_name = '".trim($nick)."' LIMIT 1");
			if(!is_numeric($authorID)){
				$wpdb->query("INSERT INTO $wpdb->users (user_login, user_pass, user_nicename, user_email, user_registered, display_name)
								VALUES ('$nick', '".md5(substr(md5(uniqid(microtime())), 0, 6)) ."', '".sanitize_title_with_dashes($nick)."', 'mail@fintaimeils.com', NOW(), '$nick')");
				$authorID = $wpdb->insert_id;
			}
			return $authorID;
		}
		return 1;
	}


	function save_comments($postID, $comAuthor, $comDate, $comBody){

		for($i=0;$i<count($comDate[0]);$i++)
		{

			$comment_date = "{$comDate[3][$i]}-".Splinder_Parser::month_numberize($comDate[2][$i])."-{$comDate[1][$i]} {$comDate[4][$i]}:01";
			$comment_date_gmt = $comment_date;
			$comment_post_ID = $postID;
		
			if(empty($comAuthor[3][$i])) $comAuthor[3][$i] = 'Error';
			if(substr($comAuthor[2][$i], 0, 7)!='http://')$comAuthor[2][$i]='';

			$comment_author = $comAuthor[3][$i];
			$comment_author_url = str_replace(".splinder.it",".splinder.com",$comAuthor[2][$i]);
			$comment_author_IP = '127.0.0.1';
		
			$comment_content = $comBody[1][$i];
			$comment_approved = 1;

			$commentdata = compact('comment_post_ID', 'comment_author', 'comment_author_url', 'comment_author_email', 'comment_author_IP', 'comment_date', 'comment_content', 'comment_approved');
			$commentdata = wp_filter_comment($commentdata);
			wp_insert_comment($commentdata);
		}
		
		echo '<div style="font-size:8px">Trovati <b>'.count($comDate[0]).'</b> commenti</div>';
	}

	
	/**
	 * cancella i post importati con il plugin 
	 * e le relative opzioni
	 *
	 */
	function delete()
	{
		global $wpdb;
		$ids = $wpdb->get_results("SELECT post_id FROM $wpdb->postmeta WHERE meta_key = 'splinder_blog'");
		
		foreach ($ids as $id) 	
			wp_delete_post($id->post_id); 
		
		$this->options_delete();		

		$wpdb->query("DELETE FROM $wpdb->postmeta WHERE meta_key = 'splinder_blog' OR meta_key = 'splinder_permalink'");
			
		echo "Ho cancellato <b>".count($ids)."</b> articoli importati tramite il plugin";			
	}
	

	/**
	 * restituisce le opzioni di default del plugin
	 *
	 * @return mixed $options
	 */
	function options($reload = false)
	{
		if (!($this->options) or $reload)
		{
			$options = get_option('splinder_import');		
			if (!is_array($options)) $options = array();
			
			$defaults = array( 
								'post_persi' => array(),	
								'blog_url' => '', 
								'permalinks' => $this->permalinks, 
								'pages' => $this->pages, 
								'imported' => array(), 
								'last_page' => -1
						); 
			
			$this->options = array_merge($defaults,$options);
		}
				
		return $this->options;			
	}
	
	function options_update($options = '')
	{
		if (!is_array($options))
		{
			$options = array( 
					'post_persi' => '', 
					'blog_url' => $this->blog_url,
					'permalinks' => $this->permalinks,
					'pages' => $this->pages,
					'imported' => $this->imported,
					'last_page' => $this->last_page
				);		
		
			update_option('splinder_import', $options);
		}
		$this->options(true);
	}	

	function options_delete()
	{
		delete_option('splinder_import');
	}
	
	/**
	 * ripulisce il nome del blog eliminando il / finale
	 *
	 * @param string $url
	 */
	function get_blogurl($url='')
	{
		if ($url != '')	$this->blog_url = (substr($url,-1,1)=='/')? substr($url,0,strlen($url)-1) : $url ;
		else 
		{
			$options = $this->options();
			$this->blog_url = $options['blog_url'];
		}
	}
	
	function analyze()
	{
		$this->get_pages();
		$this->get_all_permalinks();
		
		echo "Ho identificato ".count($this->permalinks)." articoli da importare<br/>";		
		$this->options_update();
	}
	
	/**
	 * Importa la pagina del blog
	 *
	 * @param int $number numero di pagina
	 * @param int $counter contatore di importazione
	 * @return int $counter post importati
	 */
	function import_page($number=-1,$counter=1,$page_permalinks=array())
	{
		// analizzo la pagina altrimenti uso il $page_permalinks passato al metodo
		if ($number>=0) 
		{
			if ($page_permalinks = $this->get_permalinks($this->pages[$number])) 
				$this->permalinks = array_merge($page_permalinks,$this->permalinks);
           		else die('<b style="color:red">Non ho trovato permalinks nella pagina indicata!</b>' );
		} else
			$this->permalinks = $page_permalinks;
			
		
		echo 'Ho trovato <b>'.count($page_permalinks).'</b> posts nella pagina '.($number+1).'<br/>';
		
		if (count($page_permalinks)>0)
		{
			if ($this->check_before())
				echo 'Dei quali ne ho già importati '.count(array_intersect($this->imported,$page_permalinks)).'<br/><br/>';
		
			foreach ($this->permalinks as $url)
			{	
				echo '<div style="width:150px;border:1px solid #bb0;padding:5px;color:#aaa;float:left;margin:10px">importo il post <b><a href="'.$this->blog_url.$url.'">'.$url.'</a></b><br/>';
		
				if (! $postID = $this->save($this->blog_url.$url)) 
					echo '<b style="color:#e00">errore</b>';
		
				echo '<br/><span style="float:right;font-size:8px;"><b>'.$counter.'</b></span></div>';
				
				$counter++;
			}
			echo '<br clear="all">';
	
			return $counter;
		}			
		
		return false;
	}
	
	/**
	 * questo metodo importa tutti i permalinks di tutte le pagine degli archivi
	 *
	 */
	function import_pages()
	{
		$counter = 1;
		$options = $this->options();
		
		foreach ($this->pages as $k => $page)
			if ($k > $options['last_page'])
				if (($counter) < $this->limit)
				{			
					$counter = $this->import_page($k,$counter);					
					$this->last_page = $k;
				} 
	}
	
	/**
	 * Genera i pulsanti per l'importazione delle pagine
	 *
	 * @return string
	 */
	function import_button()
	{
		$options = $this->options();
		$output = '';
		
		foreach ($options['pages'] as $k => $page)
		{
			if (($k-1)<$options['last_page']) $style='style="color:#999"';
			else $style='';
			$output .= "<input type='submit' value='".($k+1)."' name='import_page' $style/>";	
		}
		
		return $output;
	}
	
	/**
	 * Mostra il menu all'interno della dashboard di wp
	 *
	 */
	function manage() 
	{
		$options = $this->options();
		
		if ((!empty($_POST['splinder'])) && ($_GET['step']=='del'))
		{
			if ($_POST['delete'] == 'all')
			{
				echo '<div id="splinder_info" class="wrap"><h2>Cancellazione articoli</h2>';
				$this->delete(); 
			}
			elseif ($_POST['delete'] == 'option')
			{
				echo '<div id="splinder_info" class="wrap"><h2>Cancellazione opzioni</h2>';
				$this->options_delete();	
			}
			
			$options = $this->options(true);
			echo "<br/></div><br/>";
		} 				
		elseif ($_GET['step']=='2' && isset($_POST['url']) && $_POST['url'] != 'http://')
		{
			$this->get_blogurl(trim($_POST['url']));
			$this->limit = (int) $_POST['limit'];
			
			echo '<div id="splinder_info" class="wrap"><h2>Importazione articoli</h2>';
			echo "<h4>Sto analizzando il blog</h4>";
			$this->get_pages();
					
			echo '<h4>Risultato dell\'importazione</h4>';	
			$this->import_pages();			
			$this->check_results();
			$options = $this->options(true);
						
			echo 'di cui <b>'.$this->no_title.'</b> senza titolo'; 
			echo '</div><br/>';
		
		}
		elseif ( ($_GET['step']=='3') && (count($options['post_persi'])>0) )
		{	
			$this->get_blogurl();
			
			echo '<div id="splinder_info" class="wrap"><h2>Re-Importazione articoli</h2>';
			echo "<h4>Sto analizzando gli articoli persi</h4>";
			
			echo 'Ho trovato <b>'.count($options['post_persi']).'</b> posts.<br/><br/>
			Inizio l\'importazione dei post persi, il processo potrebbe impiegare alcuni minuti!<br/>
			<br/>';
			
			echo '<h4>Risultato della re-importazione</h4>';			
			$this->import_page(-1,1,$options['post_persi']);
			$this->check_results();
			$options = $this->options(true);

			echo 'di cui <b>'.$this->no_title.'</b> senza titolo';		
			echo '</div><br/>';
		}		
		elseif ($_GET['step']=='4' && isset($_POST['import_page']))
		{	
			echo '<div id="splinder_info" class="wrap"><h2>Importazione pagina '.$_POST['import_page'].'</h2>';
			$this->get_blogurl();
			$this->get_pages();
			$this->import_page(($_POST['import_page']-1));
			$this->check_results();
			echo '</div><br/>';
		}
		elseif ($_GET['step']=='5')
		{
			echo '<div id="splinder_info" class="wrap"><h2>Analisi del blog</h2>';
			$this->get_blogurl(trim($_POST['url']));
			$this->analyze();
			$options = $this->options(true);
			echo '</div><br/>';
		}

?>
<div id="splinder" class="wrap">

<?php if (!isset($_GET['step'])) { ?>
<h2>Import from Splinder/Motime - Importa da Splinder/Motime.</h2>
<p>
	Before to import your posts you have to change your template with this one:<br/>

<blockquote style='border:1px solid brown;padding:5px;font-face:courier'>
&lt;Blogger&gt;<br/>
&lt;div class='ss-permalink'>:PERMALINKS:&lt;$BlogItemPermalink$&gt;:ENDPERMALINKS:&lt;/div&gt;<br/>
&lt;div class='ss-post-title'>:POSTTITLE:&lt;$BlogItemTitle$&gt;:ENDPOSTTITLE:&lt;/div&gt;<br/>
&lt;div class='ss-post-text'>:TESTO:&lt;$BlogItemBody$&gt;:ENDTESTO:&lt;/div&gt;<br/>
&lt;div class='ss-post-date'>:POSTDATA:&lt;$BlogItemDateTime$&gt;:ENDPOSTDATA:&lt;/div&gt;<br/>
&lt;div class='ss-post-cats'>:POSTCATEG:&lt;$BlogItemCategories$&gt;:ENDPOSTCATEG:&lt;/div&gt;<br/>
&lt;div class='ss-post-author'>:POSTAUTHOR:&lt;$BlogItemAuthor$&gt;:ENDPOSTAUTHOR:&lt;/div&gt;<br/>
&lt;div class='ss-comments'>:POSTCOMMENT:&lt;$BlogItemCommentList$&gt;:ENDPOSTCOMMENT:&lt;/div&gt;<br/>
&lt;/Blogger&gt;<br/>
:BLOGPAGER:&lt;$BlogPager$&gt;:ENDBLOGPAGER:<br/>
</blockquote>

	Please note that <b>this plugin is a server-resource-killer</b>. <br/>
<br/><br/>
</p>
<?php } ?>

<!--
<div style='border:1px solid brown;padding:5px;font-face:courier'>
<h4>Le seguenti opzioni sono state salvate nel DB</h4>
Blog: <?php echo $options['blog_url']; ?><br/>
Ultima pagina salvata: <?php echo $options['last_page']; ?><br/>
Articoli identificati: <?php echo count($options['permalinks']); ?><br/>
Pagine identificate: <?php echo count($options['pages']); ?><br/>
Pagine perse <pre><?php print_r($options['post_persi']); ?></pre><br/>
</div>
<br/><br/>
-->

<?php if (!function_exists(  'curl_exec' )) : ?>
<h2>Attenzione!</h2>
Non è stata individuata una installazione valida di <b>cURL per PHP</b>, lo script non proseguirà oltre!<br/>
<?php else: ?>

<?php if (count($options['pages'])>0) { ?>
<h2>Importa le pagine singolarmente</h2>
Puoi importare singolarmente le singole pagine degli archivi del tuo vecchio blog di splinder.<br/> 
<b>Puoi importare più volte la stessa pagina</b> senza problemi, i post doppi non verranno salvati sul database.<br/> 
<form id="splindersingleimport" method="post" action="?import=splinder&amp;step=4">
<?php echo $this->import_button(); ?>
</form>
<br/><br/>
<?php } ?>

<h2>Analizza il blog</h2>
Tramite questa opzione verrà analizzato il blog ed i relativi archivi e verranno salvati i dati nelle opzioni del plugin
<form id="splindersingleimport" method="post" action="?import=splinder&amp;step=5">
<input size="30" name="url" type="text" id="urlanalizza" value="<?php echo $options['blog_url']; ?>" />
<input type="submit" value="Analizza" /></p>
</form>
<br/><br/>

<h2>Importa <?php echo ($this->limit-1); ?> post</h2>
<p>
	Tramite questa opzione, reiterabile più volte è possibile importare più di una pagina
	di archivi per volta. Di default è impostata l'importazione di <?php echo ($this->limit-1); ?> articoli.
</p>
<form id="splinderimport"  method="post" action="?import=splinder&amp;step=2">
<fieldset class="options">
<p><label for="url">Splinder/Motime URL:
	  <input size="30" name="url" type="text" id="url" value="<?php echo $options['blog_url']; ?>" />
</label>
<br/> Numero di post da importare ad ogni iterazione: 
	  <select name="limit">
	  	<option value="61">60</option>
	  	<option value="91">90</option>
	  	<option value="121">120</option>
	  	<option value="151">150</option>
	  	<option value="181">180</option>
	  	<option value="211">210</option>
	  	<option value="241">240</option>
	  	<option value="271">270</option>
	  	<option value="300">300</option>	  	
	  </select>
</p>
<p>fai attenzione a rimuovere lo / finale</p>
	<p class="submit" style="text-align: left">
	<input type="submit" value="Importa" /></p>
</fieldset>
</form>
<br/><br/>

<h2>Cancella i post/opzioni importati.</h2>
<p>Cancella da Wordpress i post importati o le opzioni del plugin.</p>
<script type="text/javascript">
function DeleteSplinder(thisform) {
	if (confirm("Vuoi veramente cancellare tutti i post importati da Splinder?")) {
		return true;
	} else {
		return false;
	}
} 
</script>
<form method="post" action="?import=splinder&amp;step=del" onsubmit="return DeleteSplinder(this.form)">
<fieldset class="options">
	<p class="submit" style="text-align:left">
		<select name="delete">
			<option value="all">Tutto</option>
			<option value="option">Opzioni</option>
		</select>
		<input type="submit" name="splinder" value="Cancella" /><br/>
	</p>
</fieldset>
</form>
<br/>
</div>
<br/><br/>
This plugin is based on <a href="http://www.terenzani.it/38/importare-i-post-di-splinder-in-wordpress/">Splinder/Motime Importer</a> by Francesco Terenzani
<br/><br/>
<?php
endif;

}  // End Option Page
	
	function Splinder_Importer()
	{	
		register_importer('splinder', __('Splinder/MoTime'), __('Import <strong>posts, comments, tags as category</strong> from a Splinder/Motime blog by <a href="http://fullo.net">Fullo.net</a>'), array ($this, 'manage'));  
	}
}

if (class_exists('Splinder_Importer')) 
{
    $Splinder_Importer = new Splinder_Importer();   
  	
    
}
?>
